<template>
    <div class="feedback">
        <div class="breadcrumbs">
            <router-link to="/main">{{$t('message.main')}}</router-link>
            <div class="circle"></div>
            <div>{{$t('message.feedback')}}</div>
        </div>

        <div class="form_container">
            <form @submit.prevent="sendFeedback" v-if='!feedback_created' class="form">
                <div class="block" style="padding-bottom: 0">
                    <div class="block-title">{{$t('message.feedback')}}</div>
                    <div class="row">
                        <div class="input_component">
                            <input
                                type="text"
                                name="name"
                                v-model='form.name'
                                :placeholder="$t('message.first_name')"
                                @input='handleCyrilic'
                                :class="{active_focus: form.name, error: (errors.name && !form.name)}"
                            >
                            <div class="lbl">{{$t('message.first_name')}}</div>
                            <span class="label">{{$t('message.required')}}</span>
                        </div>
                        <div class="input_component">
                            <v-select
                                :items="feed_ways"
                                :placeholder="$t('message.question_feedback')"
                                v-model="form.way"
                                :class="{parent_active_focus: form.way, error: (errors.way && !form.way)}"
                            >
                                <template slot="label">{{$t('message.question_feedback')}}</template>
                            </v-select>
                            <span class="label">{{$t('message.required')}}</span>
                        </div>

                        <div class="input_component phone" v-if="form.way=='телефон'">
                            <the-mask
                                type="text"
                                :mask="['+38 (0##) ###-##-##']"
                                placeholder="+38 (0##) ###-##-##"
                                v-model='form.phone'
                                :class="{active_focus: form.phone}"
                            ></the-mask>
                            <div class="lbl">{{$t('message.phone')}}</div>
                            <span class="label">{{$t('message.required')}}</span>
                        </div>

                        <div class="input_component" v-if="form.way=='email'">
                            <v-text-field
                                v-model='form.email'
                                :placeholder="$t('message.email')"
                                name='email'
                                :class="{error : (errors.email || !is_email_valid), parent_active_focus: form.email}"
                            >
                                <template slot="label">{{$t('message.email')}}</template>
                            </v-text-field>
                            <span class="label">{{$t('message.required')}}</span>
                        </div>
                    </div>

                    <div class="row flex-start-row">
                        <div class="input_component">
                            <v-select
                                :items="topics"
                                :placeholder="$t('message.question_topic')"
                                v-model="form.topic_id"
                                :class="{parent_active_focus: form.topic_id, error: (errors.topic_id && !form.topic_id)}"
                            >
                                <template slot="label">{{$t('message.question_topic')}}</template>
                            </v-select>
                            <span class="label">{{$t('message.required')}}</span>
                        </div>

                        <div class="input_component">
							<!--<textarea-->
									<!--style="padding-bottom: 2%;"-->
								<!--:placeholder="$t('message.comment')"-->
								<!--v-model="form.text"-->
								<!--name='text'-->
								<!--class="comment"-->
								<!--:class="{parent_active_focus: form.text, error: (errors.text && !form.text)}"-->
								<!--@keyup="mixin_autoResize_resize"-->
								<!--rows="0"-->
								<!--height="0"-->
							<!--&gt;</textarea>-->
							<!--<label>{{$t('message.comment')}}</label>-->
							<!--<span class="label">{{$t('message.required')}}</span>-->

                            <v-textarea
                                :placeholder="$t('message.comment')"
                                v-model="form.text"
                                name='text'
                                class="comment"
                                :class="{parent_active_focus: form.text, error: (errors.text && !form.text)}"
								auto-grow
								outlined
								rows="1"
								clearable
							>
                                <template slot="label">{{$t('message.comment')}}</template>
                            </v-textarea>

                            <span class="label">{{$t('message.required')}}</span>
                        </div>
                    </div>
                </div>

                <div class="block buttons feedback-buttons">
                    <div class="row">
                        <button class="button">
                            {{$t('message.send')}}
                        </button>
                    </div>
					<div class="questions">
						<div class="block-container">
							<div class="text">
								<div class="text_1">{{$t('message.have_question')}}</div>
								<div class="text_2">{{$t('message.have_question_second_str')}}</div>
							</div>
							<div class="image">
								<img src="/img/squares_green.svg">
							</div>
						</div>
					</div>
                </div>

            </form>
        </div>

        <div v-if='feedback_created'>
            <div class="popup_success_window feedback_success">
                <menu-component></menu-component>

                <div class="message">
                    <div class="title_message">{{$t('message.feedback_success')}}</div>

                    <div class="description">
                        <div v-html="$t('message.feedback_success_description')">
                            {{$t('message.feedback_success_description')}}
                        </div>
                    </div>

                    <!--                        <button class="button">{{$t('message.to_main')}}</button>-->
                    <div class="controls">
                        <router-link to="/" class="button">{{$t('message.main')}}</router-link>
                    </div>
                </div>

                <!--                    <div class="logo_squares"><logo-squares></logo-squares></div>-->
            </div>
        </div>
    </div>
</template>

<script>
    import Facebook from "./svg/icons/Facebook";
    import Instagramm from "./svg/icons/Instagramm";
	import mixinAutoResize from "./mixins/autoResize.js";

    export default {
		mixins: [mixinAutoResize],
        components: {
            "facebook-svg": Facebook,
            "instagramm-svg": Instagramm
        },
        data: () => {
            return {
                userData: {},
                form: {
                    topic_id: null,
                    text: null,
                    email: '',
                    name: '',
                    phone: '',
                    way: null
                },
                topics: [
                    {
                        text: 'Питання про послуги',
                        value: 1
                    },
                    {
                        text: 'Співпраця',
                        value: 2
                    },
                    {
                        text: 'Реклама та піар',
                        value: 3
                    },
                    {
                        text: 'Відгуки/Скарги',
                        value: 4
                    },
                    {
                        text: 'Інше',
                        value: 5
                    }
                ],
                // до внесения новых локализаци "НИЧЕГО" не менять
                feed_ways: [
                    'телефон',
                    'email',
                    'не потрібно зі мною зв\'язуватись'
                ],
                feedback_created: false
            }
        },
        methods: {
			forceReRender() {
				this.autoGrowHack = !this.autoGrowHack;
			},
            async sendFeedback() {
                let response = await axios.post('/feedback/create', this.form);
                let {data} = response;
                if (!data.is_valid) {
                    this.$store.commit('set_errors', data[0]);
                    // this.$modal.show('error');
                } else {
                    this.feedback_created = data.is_valid;
                    // обновляем незаполненные поля в профиле
                    this.updateProfileData();
                    // this.$modal.show('success')
                }
            },
            async updateProfileData(){
                if (this.userData) {
                    if (!this.userData.email) {
                        await axios.post('/profile_update', {
                            email: this.form.email
                        });
                    }
                }
            },
            handleCyrilic(e) {
                if (!(/[а-яА-ЯЁё]/.test(e.data)) && e.data)
                    e.target.value = e.target.value.substring(0, e.target.value.length - 1);
            },

        },
        // TODO use getterMap or someMap
        computed: {
            is_email_valid: function () {
                if (!this.form.email) return true;
                const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+)+(\.*[a-zA-Z]{2,})*))$/
                return pattern.test(this.form.email)
            },
            errors() {
                return this.$store.getters.errors;
            },
        },
        async created() {
            const response = await axios.post('/profile');
            this.userData = response.data;
            this.form.name = response.data.first_name;
            this.form.email = response.data.email;
            this.form.phone = response.data.phone;
        }

        // this.$store.state.user.user.name
        // this.$store.state.user.profile.middle_name
        // this.$store.state.user.profile.surname
        // this.$store.state.user.user.email
        // this.$store.state.user.profile.birth_date
        // this.$store.state.user.profile.sity
        // this.$store.state.user.profile.street
        // this.$store.state.user.profile.building
        // this.$store.state.user.profile.flat
    }
</script>
